Package net.sf.saxon.functions

## Class DistinctValues.DistinctIterator

- java.lang.Object
- - net.sf.saxon.functions.DistinctValues.DistinctIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `SequenceIterator`
  Enclosing class:
    DistinctValues

      public static class DistinctValues.DistinctIterator
      extends java.lang.Object
      implements SequenceIterator

  Iterator class to return the distinct values in a sequence

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DistinctIterator​(SequenceIterator base, StringCollator collator, XPathContext context)` | Create an iterator over the distinct values in a sequence

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the iterator.
    `AtomicValue` | `next()` | Get the next item in the sequence.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `forEachOrFail, getProperties, materialize`

- - ### Constructor Detail

    - #### DistinctIterator

          public DistinctIterator​(SequenceIterator base,
                                  StringCollator collator,
                                  XPathContext context)

      Create an iterator over the distinct values in a sequence
      Parameters:
        `base` - the input sequence. This must return atomic values only.
        `collator` - The comparer used to obtain comparison keys from each value; these comparison keys are themselves compared using equals().
        `context` - the XPath dynamic context

  - ### Method Detail

    - #### next

          public AtomicValue next()
                           throws XPathException

      Get the next item in the sequence.
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      For example, the iterator returned by the unparsed-text-lines() function has a close() method that causes the underlying input stream to be closed, whether or not the file has been read to completion.

      Closing an iterator is important when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `SequenceIterator`